#include <Wire.h>

#define ADT7410 0x48
#define ADT7410_CONFIG 0x03

bool ADT7410_exist;

void setup(void) {
  Serial.begin(9600);
  Wire.begin(); 

  ADT7410_exist = ADT7410_init();

}
 
void loop(void) {

  float temp;
  if(ADT7410_exist){
    if(ADT7410_MODE>0x80) temp = getTemp16bit();
    else temp = getTemp13bit();
    Serial.println(temp);
  }
  else Serial.println("No Sensor(ADT7410)");
  
  delay(200);
}




bool ADT7410_init(){
  int res;

//ADT7410 測定モード
//  13bit精度
//  NORMAL MODE   :0x00   ONE-SHOT MODE :0x20
//  1 SPS MODE    :0x40   SHUTDOWN MODE :0x60
//  16bit精度
//  NORMAL MODE   :0x80   ONE-SHOT MODE :0xA0
//  1 SPS MODE    :0xC0   SHUTDOWN MODE :0xE0
  Wire.beginTransmission(ADT7410);
  Wire.write(ADT7410_CONFIG);
  Wire.write(0x80);
  res = Wire.endTransmission();
  
  if(res>0) return false;
  else return true;
}

float getTemp13bit(){
  uint16_t val;
  float temp;
  int ival;
 
  Wire.requestFrom(ADT7410, 2);
  val = (uint16_t)Wire.read() << 8;
  val |= Wire.read();
  val >>= 3;
  ival = (int)val;
 
  if(val & (0x8000 >> 3)) {
    ival = ival  - 8192;
  }
 
  temp = (float)ival / 16.0;

  return temp;
}

float getTemp16bit(){
  uint16_t val;
  float temp;
  int ival;
 
  Wire.requestFrom(ADT7410, 2);
  val = (uint16_t)Wire.read() << 8;
  val |= Wire.read();
  ival = (long int)val;
  
  if(val & 0x8000) {
    ival = ival - 65536;
  }
 
  temp = (float)ival / 128.0;
  
  return temp;
}


